#if !defined(_Math_)
#define _Math_

#include<Complex.h>
#include<math.h>

Complex sinc(Complex arg);
double  sinc(double arg);

Complex Erf(Complex);
double  Erf(double);

double SinIntegral(double x);
//return the sine integral Integrate[Sin[t]/t, {t, 0, x}]

double CosIntegral(double x); 
//return the cosine integral EulerGamma + Log[x] + 
//                           Integrate[(Cos[t] - 1)/t, {t, 0, x}]

double ExpIntegralEi(double x);
// gives the exponential integral Integrate[Exp(u)/u,{u,x,Infinity}] 

extern "C" double drand48();

int HankelFct1(Complex Z,int OrderMin,int NumbOfMember,Complex *Value);
int HankelFct2(Complex Z,int OrderMin,int NumbOfMember,Complex *Value);
int BesselFct (Complex Z,int OrderMin,int NumbOfMember,Complex *Value);

Complex Hankel1(int N, Complex C);
Complex Hankel2(int N, Complex C);
Complex Bessel (int N, Complex C);

int ScaledHankelFct1(Complex Z,int OrderMin,int NumbOfMember,Complex *Value);
int ScaledHankelFct2(Complex Z,int OrderMin,int NumbOfMember,Complex *Value);
int ScaledBesselFct (Complex Z,int OrderMin,int NumbOfMember,Complex *Value);

Complex ScaledHankel1(int N, Complex C); //Scaled by the factor exp(-iz)
Complex ScaledHankel2(int N, Complex C); //Scaled by the factor exp(iz)
Complex ScaledBessel (int N, Complex C); //Scaled by the factor exp(-|imag(z)|)


double min(double,double);
double max(double,double);

double Abs(double  v);
int    Abs(int     v);
double Abs(Complex v);

int min(int,int);
int max(int,int);


#if !defined(__GNUC__)
double pow(double x,int n);
#endif

double RandomNormalDistribution(double StandartDeviation);
double RandomNormalDistribution();

#endif






