#include<iostream.h>
#include<Complex.h>
#include"Green.h"
 
// For all the different kind of Green's tensor, this small program write the 
// value of:
//
// 1) the Green's tensor Gel(rp,r), 
// 2) the magnetic Green's tensor Gma(rp,r), 
// 3) the farfield Green's tensor Gff(rp,n),  (n=r)
// 4) the M and the L terms



void PrintGreenTensor(GreenTensor* GT,vect3d r,vect3d rp)

{ cout<<" L\n"    <<GT->L()<<"\n";
  cout<<" M\n"    <<GT->M()<<"\n";
  cout<<" Gel\n"  <<GT->GreenE0(r,rp)<<"\n";
  cout<<" Gma\n"  <<GT->GreenM0(r,rp)<<"\n";
  cout<<" GelFF\n"<<GT->GreenFFE0(r,rp)<<"\n";
}


#define N 10 

main()
{ vect3d r=vect3d(0.1,0.2,0.3);  //Position of observation
  vect3d rp=vect3d(4,3,2);       //Position of the source
  double MeshSize=0.01;          //Size of the cell

  Complex  Kref=10;              //Wavenumber in the reference medium
  Complex  EpsilonRef=2;         //Permittivity of the reference medium

  GreenTensor* GT;

  for (int i=0;i<8;i++)
    {
    switch (i)
      {
      case 0:
	cout<<"Green2d\n";
        GT=new Green2d(Kref,EpsilonRef,MeshSize,PI/2);
	break;
      case 1:
	cout<<"Green2dTM\n";
        GT=new Green2dTM(Kref,EpsilonRef,MeshSize);
	break;
      case 2:
	cout<<"Green2dTE\n";
        GT=new Green2dTE(Kref,EpsilonRef,MeshSize);
	break;
      case 3:
	cout<<"Green3d\n";
        GT=new Green3d(Kref,EpsilonRef,MeshSize);
	break;
      case 4:
	cout<<"FGreen2d\n";
        GT=new FGreen2d(Kref,EpsilonRef,MeshSize,PI/2);
	break;
      case 5:
	cout<<"FGreen2dTM\n";
        GT=new FGreen2dTM(Kref,EpsilonRef,MeshSize);
	break;
      case 6:
	cout<<"FGreen2dTE\n";
        GT=new FGreen2dTE(Kref,EpsilonRef,MeshSize);
	break;
      case 7:
	cout<<"FGreen3d\n";
        GT=new FGreen3d(Kref,EpsilonRef,MeshSize);
	break;
      }

    PrintGreenTensor(GT, r, rp);
    delete GT;
    }
}









